import { BlobItem } from '@azure/storage-blob';
export interface Config {
    connection_string?: string;
    azure_tenant_id?: string;
    azure_client_id?: string;
    azure_client_secret?: string;
    driver?: string;
    name?: string;
    key?: string;
    local_address?: string;
    container?: string;
}
export default class AzureStorage {
    protected config: Config;
    private AzureClient;
    private _container;
    constructor(config: Config);
    getBlockBlobClient(relativePath: string): import("@azure/storage-blob").BlockBlobClient;
    container(container: string): this;
    existsContainer(container: string, options?: any): Promise<unknown>;
    createContainer(container: string, options?: any): Promise<unknown>;
    deleteContainer(container: string, options?: any): Promise<unknown>;
    /**
     * List all files within vitual folder if specified
     * If nothing is specified, root files within container will be listed
     * Disclaimer: Doesn't list virtual folders
     */
    list(prefix?: string, options?: any): Promise<BlobItem[]>;
    exists(relativePath: string, options?: any): Promise<unknown>;
    put(relativePath: string, content: any, options?: any): Promise<unknown>;
    putStream(relativePath: string, content: any): Promise<unknown>;
    delete(relativePath: string, options?: any): Promise<unknown>;
    get(relativePath: string, options?: any): Promise<unknown>;
    getStream(relativePath: string, options?: any): Promise<unknown>;
    move(relativeSrcPath: string, relativeDestPath: string, options?: any): Promise<unknown>;
    copy(relativeSrcPath: string, relativeDestPath: string, options?: any): Promise<any>;
    generateBlobSASURL(blockBlobClient: any, options?: any): Promise<string>;
    getSignedUrl(relativePath: string, options?: any): Promise<string>;
    getUrl(relativePath: string): string;
}
